const getRef = (el, binding, vnode) => {
  const ref = binding.expression ? binding.value : binding.arg
  let target = vnode.context.$refs[ref]
  if (target) {
    if (Array.isArray(target)) {
      target = target[0]
    }
    const { captureTrue, captureFalse } = binding.modifiers
    target.useCapture = captureTrue || (!captureTrue && !captureFalse)
    target.$refs.toggle = el
  }
}
export default {
  bind (...args) {
    getRef(...args)
  },
  inserted (...args) {
    getRef(...args)
  }
}
