// 生成当前时间
const NowTime = () => {
  const oDate = new Date()
  const y = oDate.getFullYear()
  const M = oDate.getMonth() + 1
  const d = oDate.getDate()
  const h = oDate.getHours()
  const m = oDate.getMinutes()
  const s = oDate.getSeconds()
  return `${y}-${M}-${d} ${h}:${m}:${s}`
}

// 默认的mark样式
let cssText = `
  position: fixed;
  opacity: .2;
  font-size: 14px;
  -webkit-transform: rotate(-15deg);
  -moz-transform: rotate(-15deg);
  -ms-transform: rotate(-15deg);
  -o-transform: rotate(-15deg);
  transform: rotate(-15deg); 
  -webkit-user-select: none;
  -moz-user-select: none;
  -ms-user-select: none;
  user-select: none;
  padding: 25px 0 25px 5px;
  box-sizing: border-box;
  white-space: nowrap;
  pointer-events: none;
  z-index: 999999;
`

// 初始化默认展示值
let wmContent = `${NowTime()} zhaopin.com`
// 范围
let markSize = {
  height: document.body.clientHeight || '',
  width: document.body.clientWidth || '',
  top: 0,
  left: 0,
}

// 初始化step
let stepX = 300
let stepY = 130
let trailList = []

const WatermarkDirective = {
  bind (el, binding) {
    // 初始化是否传入mark值
    if (binding.value && binding.value.mark) {
      wmContent = binding.value && binding.value.mark || `${NowTime()} zhaopin.com`
    }
    // 初始化xy间隔
    if (binding.value && binding.value.stepX) {
      stepX = binding.value.stepX < stepX ? stepX : binding.value.stepX
    }
    if (binding.value && binding.value.stepY) {
      stepY = binding.value.stepY < stepY ? stepY : binding.value.stepY
    }
  },
  update (el, binding) {
    if (binding.value && !binding.value.type) {
      markSize = el.getBoundingClientRect()
    } else {
      markSize = {
        height: document.body.clientHeight || '',
        width: document.body.clientWidth || '',
        top: 0,
        left: 0,
      }
    }
    const maxWidth = markSize.width
    const maxHeight = markSize.height
    let htmlString = ''
    for (let i = 0; i * stepY < maxHeight; i++) {
      for (let j = 0; j * stepX < maxWidth; j++) {
        if (trailList.indexOf('' + j * stepX + i * stepY) === -1) {
          trailList.push('' + j * stepX + i * stepY)
          htmlString += `<div style="${cssText}left:${markSize.left + j * stepX}px;top:${markSize.top + i * stepY}px;">${wmContent}</div>`
        }
      }
    }
    if (binding.value && binding.value.type) {
      document.body.insertAdjacentHTML('beforeend', htmlString)
    } else {
      el.insertAdjacentHTML('beforeend', htmlString)
    }
  }
}

const Watermark = {
  install (Vue) {
    Vue.directive('watermark', WatermarkDirective)
  },
  name: 'watermark'
}

export {
  Watermark,
  WatermarkDirective
}
