function broadcast (compName, evtName, params) {
  for (const child of this.$children) {
    const name = child.$options.name
    if (name === compName) {
      child.$emit(...[evtName].concat(params))
    } else {
      broadcast.apply(child, [compName, evtName].concat([params]))
    }
  }
}
function broadcastAll (evtName, params) {
  for (const child of this.$children) {
    const name = child.$options.name
    child.$emit(...[evtName].concat(params))
    broadcastAll.apply(child, [evtName].concat([params]))
  }
}

export default {
  methods: {
    dispatch (compName, evtName, params) {
      let parent = this.$parent || this.$root
      let name = parent.$options.name
      while (parent && (!name || name !== compName)) {
        parent = parent.$parent
        parent && (name = parent.$options.name)
      }
      parent && parent.$emit(...[evtName].concat(params))
    },
    broadcast (compName, evtName, params) {
      broadcast.call(this, compName, evtName, params)
    },
    broadcastAll (evtName, params) {
      broadcastAll.call(this, evtName, params)
    }
  }
}
